Index: src/main/org/h2/command/Parser.java
===================================================================
--- src/main/org/h2/command/Parser.java	(revision 5363)
+++ src/main/org/h2/command/Parser.java	(working copy)
@@ -3674,6 +3674,9 @@
             }
             return getKeywordOrIdentifier(s, "UNION", KEYWORD);
         case 'W':
+            if ("WITH".equals(s)) {
+                return KEYWORD;
+            }
             return getKeywordOrIdentifier(s, "WHERE", KEYWORD);
         default:
             return IDENTIFIER;
Index: src/test/org/h2/test/db/TestCompatibility.java
===================================================================
--- src/test/org/h2/test/db/TestCompatibility.java	(revision 5363)
+++ src/test/org/h2/test/db/TestCompatibility.java	(working copy)
@@ -379,6 +379,7 @@
         stat = conn.createStatement();
         stat.execute("drop table test if exists");
         stat.execute("create table test(id varchar)");
+        res = stat.executeQuery("select * from test with ur");
         res = stat.executeQuery("select * from test where id = 1 with rr");
         res = stat.executeQuery("select * from test order by id fetch next 2 rows only with rr");
         res = stat.executeQuery("select * from test order by id fetch next 2 rows only with rs");
